#ifndef __FLOU_PPM
	
	#include "libimage.h"

	int flou(const struct image*, struct image*, int, char*);

	/* Flou optimise */
	void flou_optimise(struct image*, const struct image*, int telCoef);
	void calcul_pixel_blur(int, struct image*);

	/* Flou gaussien */
	void flou_gaussien(struct image*, const struct image*, int);
	void calcul_pixel_gaussien(int,const struct image*,struct image*);

	/* Flou directionnel */
	void flou_motion(struct image*,const struct image* , int telCoef);
	void calcul_pixel_motion(int, int, const struct image*, struct image*);

	/* Flou normal */
	void flou_normal(struct image*, int);
	int calcul_pixel_normal(struct image*,int,int,int);

	/* Flou radial */
	void flou_radial(struct image*, const struct image*, int, int, int);
	void flou_radial_px(int, int, int, int, int, struct image*, 
				const struct image*);

	/* Flou circulaire */
	void spin_blur(struct image*, const struct image*, int);
	int calcTabCartEtPol(int, int);
	void calcul_pixel_motion_bouclage(int, int, const struct image*,
						struct image*);

	void usage(char*);
	
	#define __FLOU_PPM

#endif
