/* Libimage.h - le 16/10/03 Matthieu Lomon - Nicolas Maupu */
#include <stdlib.h>
#ifndef ___LIB_IMAGE_PPM

	#define CHAR_COMMENTAIRE '#'
	#define CHAR_COMMENTAIRE_CHAINE "#"
	#define FORMAT "P3"

	/* La largeur, la hauteur et le maximum de couleurs sont de type int ce
	 * qui assure au minimum 2 octets (selon la norme ANSI). On pourra donc
	 * y stocker des valeurs de -32 768 à 32 767.
	 *
	 * Le tableau de composante est de type long* et contiendra donc des
	 * long, ce qui assure selon la norme au minimum 4 octets. On pourra
	 *  donc y stocker des valeurs de - 2 147 483 648 à 2 147 483 647
	 */

	struct image
	{
		int  	saLargeur;  /* Largeur en pixels */
		int  	saHauteur;  /* Hauteur en pixels */
		int  	sonMaxCol;  /* Nombre maximal de couleur */
		int* 	sonContenu; /* Tableau de composante RGB */
	};

	/* Operations sur les couleurs */
	#define get_red(x)	(x/0x10000)
	#define get_green(x)	((x%0x10000)/0x100)
	#define get_blue(x)	(x%0x100)
	#define get_code_hexa(red,green,blue) (red*0x10000+green*0x100+blue)

	/* Copie d'images et echantillonnage d'image */
	void copie_image(struct image*,const struct image*);
	void copie_image_entete(struct image*,const struct image*);
	void copie_image_entete_px(struct image*,const struct image*,int, int);
	void copie_image_agrandie(struct image*,const struct image*,int,int);
	void change_max_color(struct image*,int);

	/* Redefinition de malloc, realloc et free */
	void* ppm_malloc(size_t);
	void* ppm_realloc(void*, size_t);
	void  ppm_free(void*);

	#define ___LIB_IMAGE_PPM

#endif

