#include "libimage.h"
#include "progress.h"
#include "effets/flou.h"

void flou_motion(struct image* telleImageDest,
		const struct image* telleImageSource, int telCoef)
{

	int laL;
	int laTailleImage;

	laTailleImage=telleImageSource->saLargeur*telleImageSource->saHauteur;

	if(telCoef==1) telCoef=2;
				
	/* Copie de l'entete de l'image source dans l'image
	 * de destination
	 */
	copie_image_entete(telleImageDest,telleImageSource);
		
	for(laL=0;laL<laTailleImage;laL++)
	{
		calcul_pixel_motion(laL,telCoef,telleImageSource,
					    telleImageDest);

		affiche_progress(laL,laTailleImage);
	}
		
	termine_progress("OK");
	
}


/* Flou motion */
void calcul_pixel_motion(int indice, int intensite,
			 const struct image* telleImageSrc,
			 struct image* telleImageDest)
{
	/* Le flou directionnel horizontal consiste en une passe de flou
	 * horizontale. Dans un soucis de simplification, chaque pixel aura la
	 * meme importance (contrairement au flou gaussien)
	 *
	 * Ex : On veut faire un flou horizontal d'intensite 10. On se trouve
	 *	au pixel d'indice x dans le tableau de composantes. On
	 * 	additionne alors les valeurs de x-5 ax+4, le pixel a traiter
	 *	est centre. On divise le resultat final par la valeur de
	 * 	l'intensite (modulo les pixels ignores qui sortent de l'image.
	 */
	
	int totalR,totalV,totalB,i,valeur,intensite_reel,tailleImage;
	
	totalR=0;
	totalV=0;
	totalB=0;
	intensite_reel=0;
	tailleImage=telleImageSrc->saLargeur*telleImageSrc->saHauteur;

   	for (i=-(intensite>>1);i<intensite>>1;i++)
   	{
   		valeur=indice+i;
   		
   		if(valeur>=0 && valeur<tailleImage)
   		{   		
      			totalR+= get_red(telleImageSrc->sonContenu[valeur]);
      			totalV+= get_green(telleImageSrc->sonContenu[valeur]);
      			totalB+= get_blue(telleImageSrc->sonContenu[valeur]);
      			intensite_reel++;
      		}
   	}

	totalR /= intensite_reel;
	totalV /= intensite_reel;
	totalB /= intensite_reel;

	telleImageDest->sonContenu[indice]=get_code_hexa(totalR,totalV,totalB);
}
