#include "libimage.h"
#include "progress.h"
#include "effets/flou.h"

/* Le flou normal (celui du sujet) */
void flou_normal(struct image* telleImage, int telCoef)
{
	int laTailleCote;
	int laMoyenne;
	int indPixel;
	int telleL, telleC;

	if(telCoef==0)
	{
		return;
	}

	
	laTailleCote=2*telCoef+1;
	
	for(telleL=0;telleL<telleImage->saHauteur;telleL++)
	{
		affiche_progress(telleL,telleImage->saHauteur);

		for(telleC=0;telleC<telleImage->saLargeur;telleC++)
		{
			indPixel=telleL*telleImage->saLargeur+telleC;

			laMoyenne=calcul_pixel_normal(telleImage,laTailleCote,
						      telleL,telleC);

			telleImage->sonContenu[indPixel]=laMoyenne;
			
		}
	}

	termine_progress("OK");
}

int calcul_pixel_normal(struct image* telleImage,int telleTailleCote,
			int telleL,int telleC)
{
	int laL,laC;
	int laMoyenneR, laMoyenneV, laMoyenneB;
	int cont,leNb,indPixel;
	int laLargeur;
	int laHauteur;
	int indiceCote;
	int curLig;
	int curCol;

	laMoyenneR=0;
	laMoyenneV=0;
	laMoyenneB=0;
	cont=0;
	laLargeur=telleImage->saLargeur;
	laHauteur=telleImage->saHauteur;
	indiceCote=telleTailleCote/2;


	for(laL=-indiceCote; laL<=indiceCote; laL++)
	{
		/* Ligne courante */
		curLig=telleL+laL;

		for(laC=-indiceCote; laC<=indiceCote; laC++)
		{
			/* Colonne Courante */
			curCol=telleC+laC;

			if( curLig<laHauteur && curCol<laLargeur &&
			    curLig>=0 && curCol>=0 )
			{
				/* Indice du pixel courant */
				indPixel=curLig*laLargeur+curCol;
				leNb=telleImage->sonContenu[indPixel];


				laMoyenneR+=get_red(leNb);
				laMoyenneV+=get_green(leNb);
				laMoyenneB+=get_blue(leNb);

				cont++;
			}
		}/*for laC*/
	}/*for laL*/

	/* Calcul des moyennes */
	laMoyenneR/=cont;
	laMoyenneV/=cont;
	laMoyenneB/=cont;

	return get_code_hexa(laMoyenneR, laMoyenneV, laMoyenneB);	
}
