/* quelerouge.c - Extraction de la composante rouge d'une image PPM
 * ____________________________________________________________________
 * Extrait la composante rouge d'une image. Les autres composantes
 * sont mises a 0
 * ____________________________________________________________________
 */

#include <stdio.h>
#include <stdlib.h>
#include "io.h"
#include "effets/quunecouleur.h"

int main(int argc, char** argv)
{
	struct image lImage;
	char* leFichierDest;
	int leRetour;

	if(argc!=2)
	{
		fprintf(stderr,"usage: %s [image_source]\n",argv[0]);
		return ERROR_ARGS;
	}

	leRetour=get_image(&lImage, argv[1]);
	if(leRetour==NO_ERROR)
	{
		/* Generation du nom de fichier */
		leFichierDest=get_file_name(argv[1],"_R.ppm");

		/* Application du filtre */
		quunecouleur(&lImage,get_code_hexa(lImage.sonMaxCol,0,0));

		/* Ecriture de l'image */
		leRetour=create_image(&lImage, leFichierDest);

		/* Desallocation */
		ppm_free((void*)lImage.sonContenu);
		ppm_free((void*)leFichierDest);
	}

	return leRetour;
}
