#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "io.h"
#include "effets/quunecouleur.h"

int main(int argc, char** argv)
{
	struct image lImgR, lImgV, lImgB;
	char* leFichierRedDest;
	char* leFichierGreenDest;
	char* leFichierBlueDest;
	int leRetour;

	if(argc!=2)
	{
		fprintf(stderr,"usage: %s [image_source]\n",argv[0]);
		return ERROR_ARGS;
	}

	leRetour=get_image(&lImgR, argv[1]);
	if(leRetour==NO_ERROR)
	{
		/* Generation des noms des fichiers de destination */
		leFichierRedDest=get_file_name(argv[1],"_R.ppm");
		leFichierGreenDest=get_file_name(argv[1],"_V.ppm");
		leFichierBlueDest=get_file_name(argv[1],"_B.ppm");

		copie_image(&lImgV,&lImgR);
		copie_image(&lImgB,&lImgR);
	
		/* Rouge */
		quunecouleur(&lImgR,get_code_hexa(lImgR.sonMaxCol,0,0));
		leRetour=create_image(&lImgR, leFichierRedDest);

		/* Vert */
		quunecouleur(&lImgV,get_code_hexa(0,lImgV.sonMaxCol,0));
		leRetour=create_image(&lImgV, leFichierGreenDest);

		/* Bleu */
		quunecouleur(&lImgB,get_code_hexa(0,0,lImgB.sonMaxCol));
		leRetour=create_image(&lImgB, leFichierBlueDest);

		/* Desallocation */
		ppm_free((void*)lImgR.sonContenu);
		ppm_free((void*)lImgV.sonContenu);
		ppm_free((void*)lImgB.sonContenu);

		ppm_free((void*)leFichierRedDest);
		ppm_free((void*)leFichierGreenDest);
		ppm_free((void*)leFichierBlueDest);
	}

	return leRetour;
}
