/* progress.c - Permet d'afficher la progression de differentes actions */

#include <stdio.h>
#include "progress.h"

/* Affiche les points indiquant la progression
 *
 * param: telIndiceCourant : l'indice courant de la progression
 * param: telTotal : total de la progression
 *
 * retour : pas de retour
 */
int precedent=-1;
int nbIteration=0;

void affiche_progress(int telIndiceCourant,int telTotal)
{
	int val;
	int i;

	if(telTotal<=POINT)
	{
		for(i=0;i<=(int)POINT/telTotal;i++)
		{
			printf(".");
		}
		fflush(stdout);

		return;
	}

	val=(int)telIndiceCourant*POINT/telTotal;
	if(precedent!=val)
	{
		if(nbIteration<POINT)
		{
			printf(".");
			nbIteration++;
		}
	}
	precedent=val;
	fflush(stdout);
}

/* Termine la barre de progression en affichant un message
 *
 * param : telleChaine : Message a afficher
 *
 * retour : pas de retour
 */
void termine_progress(const char* telleChaine)
{
	int i=0;
	if(nbIteration<POINT)
	{
		for(i=0; i<POINT-nbIteration; i++)
		{
			printf(".");
		}
	}
	
	printf(" [%s]\n",telleChaine);
	nbIteration=0;
}
